{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.View.Widget.Sidebar where

import Bamboo.Helper.Env hiding (rss_link)
import qualified Bamboo.Type.State as State

import qualified Data.Set as Set
import qualified Bamboo.Config.Global as G
import qualified Bamboo.Type.StaticWidget as Sidebar
import Bamboo.View.Widget.Helper

-- model
import qualified Bamboo.Model.Tag as Tag

-- view

sidebar c state = 
  div_class_id c "sidebar" << unordList formatted_list
  where
    stock_list = 
      [ feed state
      , tag_list $ state.State.tags
      ] 
    custom_list = G.sidebar.map (\x -> h2 << x.Sidebar.name +++ x.markup)
    formatted_list = (stock_list ++ custom_list) .intersperse hr

feed state = toHtml
  [ h2 << "Subscribe"
  , p ! [theclass "feed"] << rss_link state
  ]

rss_link = rss_url_link_pair >>> snd
tag_list tags = toHtml
  [ h2 << "Tags"
  , unordList $ tags.Tag.sorted.map tag_link]
  
tag_link x = ( hotlink (G.root / x.Tag.uid) << x.Tag.name ) +++ ( " (" ++ x.Tag.resources.Set.size.show ++ ")" )